# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011-2012 E-MIPS Electronica e Informatica
#               All Rights Reserved (<http://www.e-mips.com.ar>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp import models, fields, api
from openerp.tools.translate import _

class AccountInvoice(models.Model):
    _name = "account.invoice"
    _inherit = "account.invoice"

    amount_untaxed = fields.Float(compute='_compute_amount_all')
    amount_tax = fields.Float(compute='_compute_amount_all')
    amount_total = fields.Float(compute='_compute_amount_all')

    @api.depends('invoice_line.price_subtotal')
    def _compute_amount_all(self):
        for order in self:
            amount_tax = amount_untaxed = 0.0
            currency = order.currency_id.with_context(date=order.date_invoice or fields.Date.context_today(order))
            for line in order.invoice_line:
                amount_untaxed += line.price_subtotal
                amount_tax += (line.quantity * line.price_unit) - line.price_subtotal
            order.amount_tax = currency.round(amount_tax)
            order.amount_untaxed = currency.round(amount_untaxed)
            order.amount_total = currency.round(amount_tax + amount_untaxed)
